# Create integration configuration

POST https://app.launchdarkly.com/api/v2/integration-configurations/keys/{integrationKey}
Content-Type: application/json

Create a new integration configuration. (Excludes [persistent store](https://launchdarkly.com/docs/api/persistent-store-integrations-beta) and [flag import configurations](https://launchdarkly.com/docs/api/flag-import-configurations-beta).)

Reference: https://launchdarkly.com/docs/api/integrations-beta/create-integration-configuration

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: LaunchDarkly REST API
  version: 1.0.0
paths:
  /api/v2/integration-configurations/keys/{integrationKey}:
    post:
      operationId: create-integration-configuration
      summary: Create integration configuration
      description: >-
        Create a new integration configuration. (Excludes [persistent
        store](https://launchdarkly.com/docs/api/persistent-store-integrations-beta)
        and [flag import
        configurations](https://launchdarkly.com/docs/api/flag-import-configurations-beta).)
      tags:
        - subpackage_integrationsBeta
      parameters:
        - name: integrationKey
          in: path
          description: The integration key
          required: true
          schema:
            type: string
            format: string
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Integration Configuration response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IntegrationConfigurationsRep'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidRequestErrorRep'
        '401':
          description: Invalid access token
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedErrorRep'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenErrorRep'
        '404':
          description: Integration key not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundErrorRep'
        '409':
          description: Status conflict
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StatusConflictErrorRep'
        '429':
          description: Rate limited
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RateLimitedErrorRep'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/IntegrationConfigurationPost'
servers:
  - url: https://app.launchdarkly.com
  - url: https://app.launchdarkly.us
components:
  schemas:
    HeaderItems:
      type: object
      properties:
        name:
          type: string
        value:
          type: string
      title: HeaderItems
    HMACSignature:
      type: object
      properties:
        headerName:
          type: string
        hmacSecretFormVariableKey:
          type: string
      title: HMACSignature
    Endpoint:
      type: object
      properties:
        headers:
          type: array
          items:
            $ref: '#/components/schemas/HeaderItems'
        hmacSignature:
          $ref: '#/components/schemas/HMACSignature'
        method:
          type: string
        url:
          type: string
      title: Endpoint
    OptionsArray:
      type: object
      properties:
        label:
          type: string
        value:
          type: string
      title: OptionsArray
    DynamicOptionsParser:
      type: object
      properties:
        optionsItems:
          $ref: '#/components/schemas/OptionsArray'
        optionsPath:
          type: string
      title: DynamicOptionsParser
    DynamicOptions:
      type: object
      properties:
        endpoint:
          $ref: '#/components/schemas/Endpoint'
        parser:
          $ref: '#/components/schemas/DynamicOptionsParser'
      title: DynamicOptions
    FormVariable:
      type: object
      properties:
        key:
          type: string
        name:
          type: string
        type:
          type: string
        description:
          type: string
        placeholder:
          type: string
        isOptional:
          type: boolean
        defaultValue:
          description: Any type
        allowedValues:
          type: array
          items:
            type: string
        dynamicOptions:
          $ref: '#/components/schemas/DynamicOptions'
      title: FormVariable
    ApprovalsCapabilityConfig:
      type: object
      properties:
        additionalFormVariables:
          type: array
          items:
            $ref: '#/components/schemas/FormVariable'
          description: The additional form variables for the approvals capability
      title: ApprovalsCapabilityConfig
    ActionSpecifier:
      type: string
      title: ActionSpecifier
    StatementPostEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: StatementPostEffect
    StatementPost:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> field must be empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> field must be empty to use this field.
        effect:
          $ref: '#/components/schemas/StatementPostEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
      required:
        - effect
      title: StatementPost
    StatementPostList:
      type: array
      items:
        $ref: '#/components/schemas/StatementPost'
      title: StatementPostList
    AuditLogEventsHookCapabilityConfigPost:
      type: object
      properties:
        statements:
          $ref: '#/components/schemas/StatementPostList'
          description: >-
            The set of resources you wish to subscribe to audit log
            notifications for.
      title: AuditLogEventsHookCapabilityConfigPost
    CapabilityConfigPost:
      type: object
      properties:
        approvals:
          $ref: '#/components/schemas/ApprovalsCapabilityConfig'
          description: The approvals capability configuration for this integration
        auditLogEventsHook:
          $ref: '#/components/schemas/AuditLogEventsHookCapabilityConfigPost'
          description: >-
            The audit log events hook capability configuration for the
            integration
      title: CapabilityConfigPost
    IntegrationConfigurationPost:
      type: object
      properties:
        name:
          type: string
          description: The name of the integration configuration
        enabled:
          type: boolean
          description: >-
            Whether the integration configuration is enabled. If omitted,
            defaults to true
        tags:
          type: array
          items:
            type: string
          description: Tags for the integration
        configValues:
          type: object
          additionalProperties:
            description: Any type
          description: >-
            The unique set of fields required to configure the integration.
            Refer to the <code>formVariables</code> field in the corresponding
            <code>manifest.json</code> at
            https://github.com/launchdarkly/integration-framework/tree/main/integrations
            for a full list of fields for the integration you wish to configure.
        capabilityConfig:
          $ref: '#/components/schemas/CapabilityConfigPost'
          description: The capability configuration for the integration
      required:
        - name
        - configValues
      title: IntegrationConfigurationPost
    Link:
      type: object
      properties:
        href:
          type: string
          description: The URL of the link
        type:
          type: string
          description: The type of the link
      title: Link
    UnixMillis:
      type: integer
      format: int64
      title: UnixMillis
    ActionIdentifier:
      type: string
      title: ActionIdentifier
    AccessDeniedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessDeniedReasonEffect
    AccessDeniedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessDeniedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessDeniedReason
    AccessDenied:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessDeniedReason'
      required:
        - action
        - reason
      title: AccessDenied
    AccessAllowedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessAllowedReasonEffect
    AccessAllowedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessAllowedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessAllowedReason
    AccessAllowedRep:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessAllowedReason'
      required:
        - action
        - reason
      title: AccessAllowedRep
    Access:
      type: object
      properties:
        denied:
          type: array
          items:
            $ref: '#/components/schemas/AccessDenied'
        allowed:
          type: array
          items:
            $ref: '#/components/schemas/AccessAllowedRep'
      required:
        - denied
        - allowed
      title: Access
    StatementEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: StatementEffect
    Statement:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/StatementEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
      required:
        - effect
      title: Statement
    AuditLogEventsHookCapabilityConfigRep:
      type: object
      properties:
        statements:
          type: array
          items:
            $ref: '#/components/schemas/Statement'
          description: >-
            The set of resources you wish to subscribe to audit log
            notifications for.
      title: AuditLogEventsHookCapabilityConfigRep
    CapabilityConfigRep:
      type: object
      properties:
        approvals:
          $ref: '#/components/schemas/ApprovalsCapabilityConfig'
          description: The approvals capability configuration for this integration
        auditLogEventsHook:
          $ref: '#/components/schemas/AuditLogEventsHookCapabilityConfigRep'
          description: >-
            The audit log events hook capability configuration for the
            integration
      title: CapabilityConfigRep
    IntegrationConfigurationsRep:
      type: object
      properties:
        _links:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/Link'
          description: The location and content type of related resources
        _id:
          type: string
          description: The unique identifier for this integration configuration
        name:
          type: string
          description: A human-friendly name for the integration
        _createdAt:
          $ref: '#/components/schemas/UnixMillis'
          description: The time the integration configuration was created
        _integrationKey:
          type: string
          description: The type of integration
        tags:
          type: array
          items:
            type: string
          description: An array of tags for this integration
        enabled:
          type: boolean
          description: Whether the integration is currently active
        _access:
          $ref: '#/components/schemas/Access'
          description: >-
            Details on the allowed and denied actions for this integration
            configuration
        configValues:
          type: object
          additionalProperties:
            description: Any type
          description: >-
            Details on configuration for an integration of this type. Refer to
            the <code>formVariables</code> field in the corresponding
            <code>manifest.json</code> for a full list of fields for each
            integration.
        capabilityConfig:
          $ref: '#/components/schemas/CapabilityConfigRep'
          description: The capability configuration for the integration
        snowflakeSetupScript:
          type: string
          description: >-
            Consolidated SQL script for Snowflake Warehouse Native
            Experimentation setup. Present only for setup endpoint responses.
      required:
        - _links
        - _id
        - name
      title: IntegrationConfigurationsRep
    InvalidRequestErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: InvalidRequestErrorRep
    UnauthorizedErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: UnauthorizedErrorRep
    ForbiddenErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: ForbiddenErrorRep
    NotFoundErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: NotFoundErrorRep
    StatusConflictErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: StatusConflictErrorRep
    RateLimitedErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: RateLimitedErrorRep
  securitySchemes:
    ApiKey:
      type: apiKey
      in: header
      name: Authorization

```

## SDK Code Examples

```python
import requests

url = "https://app.launchdarkly.com/api/v2/integration-configurations/keys/integrationKey"

payload = {
    "name": "Example integration configuration",
    "configValues": {
        "optional": "an optional property",
        "required": "the required property",
        "url": "https://example.com"
    }
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.launchdarkly.com/api/v2/integration-configurations/keys/integrationKey';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"name":"Example integration configuration","configValues":{"optional":"an optional property","required":"the required property","url":"https://example.com"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.launchdarkly.com/api/v2/integration-configurations/keys/integrationKey"

	payload := strings.NewReader("{\n  \"name\": \"Example integration configuration\",\n  \"configValues\": {\n    \"optional\": \"an optional property\",\n    \"required\": \"the required property\",\n    \"url\": \"https://example.com\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.launchdarkly.com/api/v2/integration-configurations/keys/integrationKey")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Example integration configuration\",\n  \"configValues\": {\n    \"optional\": \"an optional property\",\n    \"required\": \"the required property\",\n    \"url\": \"https://example.com\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://app.launchdarkly.com/api/v2/integration-configurations/keys/integrationKey")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Example integration configuration\",\n  \"configValues\": {\n    \"optional\": \"an optional property\",\n    \"required\": \"the required property\",\n    \"url\": \"https://example.com\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://app.launchdarkly.com/api/v2/integration-configurations/keys/integrationKey', [
  'body' => '{
  "name": "Example integration configuration",
  "configValues": {
    "optional": "an optional property",
    "required": "the required property",
    "url": "https://example.com"
  }
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.launchdarkly.com/api/v2/integration-configurations/keys/integrationKey");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Example integration configuration\",\n  \"configValues\": {\n    \"optional\": \"an optional property\",\n    \"required\": \"the required property\",\n    \"url\": \"https://example.com\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Example integration configuration",
  "configValues": [
    "optional": "an optional property",
    "required": "the required property",
    "url": "https://example.com"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.launchdarkly.com/api/v2/integration-configurations/keys/integrationKey")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```